/****************************************************************************/
/*																			*/
/*		VisualMonitor_E[hTvvOiREALiŁj				*/
/*																			*/
/*			X^[gAbv												*/
/*																			*/
/*			Copyright	:: ijAt@vWFNg						*/
/*			Cpu			:: SH7044F(SH2)										*/
/*			Language	:: GCC												*/
/*			File Name	:: boot.c											*/
/*																			*/
/****************************************************************************/
#include	"sh7040s.h"
#include	"gmachine.h"
#include	"userlog.h"
#include	"c:\reali\include\reali.h"	/*REALi CXg[ꂽɂ
                                          pXwύXĉ*/

#define		UserLogAdd	0x0043f000		/* ޯpRAM̈̐擪w 	*/

/********************************/
/*	vg^Cv錾			*/
/********************************/
void	boot(void);
void	ap_main(void);
void	port_init(void),int_init(void);
void	CMT_timer_init(void);
void	task1(void),task2(void),task3(void);
void	TLogPut(char *);
void	cmt0_1ms(void);

extern void	itim_hdr(void);

/********************************/
/*	O[oϐ錾			*/
/********************************/
long	count;

void boot()
{
	ap_main();
}

/**/
INT reali_stk[0x2000];
T_SYS const t_mysys = {
		reali_stk,						/* ̈̐擪Ԓn				*/
		sizeof(reali_stk),				/* ̈̃TCY				*/
		3,								/* őDx						*/
		3,								/* ő^XN						*/
		0,								/* CxgtO					*/
		1,								/* Z}tH						*/
		0,								/* C{bNX					*/
		0,								/* v[					*/
		0,								/* Nnh				*/
		0,								/* A[nh				*/
		SR_IMS07,						/* 荞݃}XN					*/
		1								/* ZJEg					*/
};
/**/
/************************************************************/
/*	C												*/
/************************************************************/
void ap_main(void)
{
	ER er;

	/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
	/* ́A[U[vOdlɉăR[fBOĉB	*/
	/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
	/*++++++++++++++++++++++++++*/
	/* ȉ͎QlvOł */
	/*++++++++++++++++++++++++++*/

	chg_ims(SR_IMS14);
	port_init();						/* I/O|[gݒ				*/
	int_init();							/* 荞݃Rg[ݒ		*/
	UserLogInit(UserLogAdd);			/* [U[OAhXZbg		*/

	ini_sys((T_SYS *)(&t_mysys));		/* VXȅ					*/

	UserLogPut("*-------------------------------------------*");
	UserLogPut("*       <<< REALi Sample Program >>>        *");
	UserLogPut("*-------------------------------------------*");

	UserLogPut("create task1 [priority=2]");
	er=	cre_tsk(1,task1,2,0x400);		/* ^XN1 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk1 error");
	}

	UserLogPut("create task2 [priority=2]");
	er = cre_tsk(2,task2,2,0x400);		/* ^XN2 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk2 error");
	}

	/* AChO^XNƂĎgp */
	UserLogPut("create task3 [priority=1]");
	er = cre_tsk(3,task3,1,0x400);		/* ^XN3 ̐					*/
	if( er != E_OK ){
		UserLogPut("cre_tsk3 error");
	}

	sta_sys(3);							/* }`^XN̊Jn				*/
										/* ^XN3 N					*/
	for(;;);
}

/************************************************************/
/*	I/O|[gݒ										*/
/************************************************************/
void port_init(void)
{
	PFC.PACRL1.WORD = 0x1540;			/* PA15,RD WRH WRL CS1 PA10~8		*/
	PFC.PACRL2.WORD = 0x0140;			/* PA7~0							*/

	PFC.PBCR1.WORD = 0x000a;			/* A21,20							*/
	PFC.PBCR2.WORD = 0xa005;			/* A19~16 PB5~2						*/

	PFC.PCCR.WORD = 0xffff;				/* A15~0							*/

	PFC.PDCRL.WORD = 0xFFFF;			/* D15~0							*/

	PFC.PECR1.WORD = 0x0000;			/* PE15~8							*/
	PFC.PECR2.WORD = 0x0000;			/* PE7~0							*/
	PFC.IFCR.WORD = 0x0000;

	PFC.PAIORL.WORD = 0x87ff;			/* [OUT]PA15,10~0   [IN]--			*/
	PFC.PBIOR.WORD = 0x003c;			/* [OUT]PA5~2       [IN]--			*/
	PFC.PEIOR.WORD = 0xffff;			/* [OUT]PE15~0      [IN]--			*/
}

/************************************************************/
/*	CMT0^C}ݒ										*/
/************************************************************/
void CMT_timer_init(void)
{
	def_int_hdr( 144,(void*)itim_hdr);	/* 荞݃nh̐ݒ			*/
	CMT0.CMCOR = 0x0c00-1;				/* 1ms ^C}Zbg					*/
	CMT0.CMCSR.BIT.CMIE = 1;			/* RyA}b`荞݂		*/
	CMT.CMSTR.BIT.STR0 = 1;				/* CMCNT0 JEgX^[g			*/
}

/************************************************************/
/*	荞݃Rg[ݒ							*/
/************************************************************/
void int_init(void)
{
										/* D惌xݒ 15 <- 0  0=MASK	*/
	INTC.IPRG.WORD = 0x0070;			/* CMT0D惌x = 7				*/
}

/************************************************************/
/*	TASK1													*/
/************************************************************/
void task1(void)
{
	static char	flag;

	TLogPut("***** TASK1 START !! *****");
	count = 0;
	while(1){
		++count;
		if( count >= 1000 ) {
			count = 0;
			if( flag == 0 ) {
				flag = 1;
				PA.DR.WORD.L = 0x87e7;	/* o`@nm						*/
			} else {
				flag = 0;
				PA.DR.WORD.L = 0x0000;	/* o`@nee						*/
			}
		}
	}
}

/************************************************************/
/*	TASK2													*/
/************************************************************/
void task2(void)
{
	static char	flag;

	TLogPut("***** TASK2 START !! *****");
	while(1){
		wai_tsk(3000);					/* 3bҋ@							*/
		if( flag == 0 ) {
			flag = 1;
			PE.DR.WORD = 0xffff;		/* PE ON							*/
		} else {
			flag = 0;
			PE.DR.WORD = 0x0000;		/* PE OFF							*/
		}
	}
}

/************************************************************/
/*	TASK3 iAChO^XNj							*/
/************************************************************/
void task3(void)
{
	CMT_timer_init();					/* CMT^C}ݒ				*/
	sta_tsk(1);							/* ^XN1 N					*/
	sta_tsk(2);							/* ^XN2 N					*/
	TLogPut("***** TASK3 START !! *****");
	TLogPut("  TASK3 change pri 1 -> 3");
	chg_pri(TSK_SELF,3);				/* Dx 1 -> 3 ɕύX			*/

	for(;;);
}

/************************************************************/
/*	^XÑ[U[O								*/
/************************************************************/
void TLogPut(char *s)
{
	wai_sem(1);							/* Z}tH҂					*/
	UserLogPut( s );
	sig_sem(1);							/* Z}tHM					*/
}

/************************************************************/
/*	CMT0^C}荞݁i1msj								*/
/************************************************************/
void cmt0_1ms(void)
{
	CMT0.CMCSR.WORD &= ~0x0080;			/* CMF NA						*/

	irot_rdq(2);						/* ^XNfBL[]			*/
	sys_clk();
	sys_tim();
	ret_int();
}
