#include	"7046s.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0x0023F000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	mtu0_init(void);
void	int_mtu0(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* oXݒ */
	BSC.BCR1.WORD = 0x600e;				/*CS0:8bit*/
	BSC.BCR2.WORD = 0xfcee;				/*CS0:AChTCNȂ*/
	BSC.WCR1.WORD = 0xfff2;				/*CS0 2Wait*/
	
	/* hn|[gݒ */
	PFC.PACRL1.WORD = 0x0005;			/*RXD3ATXD3ARDAA5`A0*/
	PFC.PACRL2.WORD = 0x3000;			/*OUT : PA15`10APA7*/
	PFC.PACRL3.WORD = 0x033f;
	PFC.PAIORL.WORD = 0xfc80;
	
	PFC.PBCR1.WORD = 0x0000;			/*A17AA16*/
	PFC.PBCR2.WORD = 0x0005;			/*OUT : PB5`2*/
	PFC.PBIOR.WORD = 0x003c;
	
	PFC.PDCRL1.WORD = 0x00ff;			/*D7`D0*/
	PFC.PDCRL2.WORD = 0x0000;			/*OUT : PD8*/
	PFC.PDIORL.WORD = 0x0000;
	
	PFC.PECRH.WORD = 0x0fff;			/*A15`A6AWRLACS0*/
	PFC.PECRL1.WORD = 0x0030;			/*OUT : PE15`11A9A8A3`1*/
	PFC.PECRL2.WORD = 0xff03;
	PFC.PEIORH.WORD = 0x0000;
	PFC.PEIORL.WORD = 0xfb0e;
	
	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	data;
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	mtu0_init();						/*	MTU0					*/

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	MST.CR2.WORD &= ~0x1000;			/*CMT ̃X^oC[h*/
	
	def_int_hdr(144,(void*)int_cmi0);	/*荞݃nh̐ݒ			*/
	INTC.IPRG.WORD		|= 0x0070;		/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.WORD		&= ~0x0001;		/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD		= 0x0040;		/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR			= 30720-1;		/*	(24.576MHz/8)/30720 = 10msec	*/
	CMT.CMSTR.WORD		|= 0x0001;		/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*CMF NA*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		PA.DRL.WORD |= 0xfc80;			/*	Port A	*/
		flag = 0;
	} else {
		PA.DRL.WORD &= ~0xfc80;			/*	Port A	*/
		flag = 1;
	}
	UserLogTimer++;

}

/************************************/
/*	MTU ϰƼ					*/
/************************************/
void mtu0_init(void)
{
	MST.CR2.WORD &= ~0x2000;			/*MTU ̃X^oC[h*/
	
	def_int_hdr(88,(void*)int_mtu0);	/*荞݃nh̐ݒ			*/
	INTC.IPRD.WORD		= 0x7000;		/*	MTU0 InterruptLevel = 7			*/

	MTU0.TCR.BYTE		= 0x23;			/*sfq`̃RyA}b`			*/
										/*オGbWŃJEg		*/
										/*Ӂ^USŃJEg				*/
	MTU0.TIOR.BYTE.H	= 0x00;			/*TGR0B,TGR0A						*/
	MTU0.TIOR.BYTE.L	= 0x00;			/*TGR0D,TGR0C						*/
	MTU0.TIER.BYTE		= 0x41;			/*sfe`荞ݗv		*/
	MTU0.TGRA			= 1920-1;		/*TJE^					*/
	MTU0.TCNT			= 0x0000;		/*JE^NA					*/
	MTU0.TSR.BYTE		= 0x00;			/*Xe[^XNA					*/

	MTU.TSTR.BYTE		= 0x01;			/*X^[gWX^					*/
}

/********************************************/
/*	MTU荞								*/
/********************************************/
#pragma interrupt
void int_mtu0(void)
{
	static char		flag;
	static short	count = 0;
	unsigned char	wk;

	wk = MTU0.TSR.BYTE;					/*TGFANA*/
	MTU0.TSR.BYTE = 0xc0;

	if( flag == 0 ) {
		PB.DR.WORD |= 0x003c;			/*	Port B	*/
		flag = 1;
	} else {
		PB.DR.WORD &= ~0x003c;			/*	Port B	*/
		flag = 0;
	}

	/*	LEDON/OFF	*/
	count++;
	if ( 100 <= count ) {
		count = 0;
		PE.DRL.WORD ^= 0x8000;			/*	Port E	*/
	}
}
