/****************************************************************************/
/*																			*/
/*		SH1 / SH2 MPU ˑ												*/
/*																			*/
/*			Copyright	:: ijAt@vWFNg						*/
/*			Cpu			:: SH1 / SH2										*/
/*			Language    :: GCC												*/
/*			File Name   :: gmachine.h										*/
/*																			*/
/****************************************************************************/
/*----------------------------------------------------------------------------
@\  荞݃}XN̐ݒB
  unsigned short mask : 荞݃}XN 0 - 15
ߒl  void
----------------------------------------------------------------------------*/
void set_imask( unsigned short mask )
{
	unsigned long uh;

	mask <<= 4;
	mask &= 0x00f0;
	asm("	stc	sr,%0	":"=r"(uh):);
	uh &= 0xffffff0f;
	uh = uh | mask;
	asm("	ldc	%0,sr "::"r"(uh));
}

/*----------------------------------------------------------------------------
@\  荞݃}XN擾
  void
ߒl  unsigned shor 荞݃}XN̒l  0 - 15
----------------------------------------------------------------------------*/
unsigned short get_imask( void )
{
	unsigned long uh;

	asm("	stc	sr,%0	":"=r"(uh):);
	uh &= 0x00f0;
	uh >>= 4;
	return ( unsigned short )uh;
}

/*----------------------------------------------------------------------------
@\  CR WX^ɒlݒ肷
  unsigned long cr : ݒ肷l
ߒl  void
----------------------------------------------------------------------------*/
void set_cr( unsigned long cr )
{
	asm("	mov		%0,r0 "::"r"(cr) );
	asm("	ldc		r0,sr ");
}

/*----------------------------------------------------------------------------
@\  CR WX^̒l擾
  void
ߒl  unsigned long CRWX^̒l
----------------------------------------------------------------------------*/
unsigned long get_cr( void )
{
	unsigned long cr;

	asm("	stc	sr,%0	":"=r"(cr):);
	return cr;
}

/*----------------------------------------------------------------------------
@\  VBR(xN^[x[XWX^)̐ݒςBxN^[e[u̕ύX
  void base xN^[e[u̐擪Ԓn
ߒl  void
----------------------------------------------------------------------------*/
void set_vbr( void *base)
{
	asm("	ldc		%0,vbr "::"r"(base));
}

/*----------------------------------------------------------------------------
@\  VBR(xN^[x[XWX^)擾B
  void
ߒl  void * : xN^[e[u̐擪Ԓn
----------------------------------------------------------------------------*/
void *get_vbr( void )
{
	unsigned long *vbr;

	asm("	stc vbr,%0 ":"=r"(vbr):);
	return (void *)vbr;
}

/*----------------------------------------------------------------------------
@\  荞݃nh̐ݒB
  unsigned short  intno  : 荞݃xN^ԍ 0 - 255
  void *inthdr(void)     : 荞ݏ̃|C^
ߒl  void
----------------------------------------------------------------------------*/
void def_int_hdr( unsigned short  intno, void *inthdr(void) )
{
	unsigned long *vbr;

	vbr = (unsigned long*)get_vbr();
	vbr += intno;
	*vbr=(unsigned long)inthdr;
}

/*----------------------------------------------------------------------------
@\  X[vԂɈڍs
  void
ߒl  void
----------------------------------------------------------------------------*/
void sleep( void )
{
	asm(" sleep ");
}
