#include	"sh7050s.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0x0043F000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	atu0_init(void);
void	int_atu0(void);

long	UserLogTimer = 0;


/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* oXݒ */
	BSC.BCR1.WORD	= 0x000f;			/*	CS0 16bit					*/
										/*	CS1 16bit					*/
										/*	CS2 16bit					*/
										/*	CS3 16bit					*/
	BSC.BCR2.WORD	= 0x0000;			/*	CS0 AChTCN 0		*/
										/*	CS1 AChTCN 0		*/
										/*	CS2 AChTCN 0		*/
										/*	CS3 AChTCN 0		*/
										/*	CS0 AANZXAChTCN 0	*/
										/*	CS1 AANZXAChTCN 0	*/
										/*	CS2 AANZXAChTCN 0	*/
										/*	CS3 AANZXAChTCN 0	*/
										/*	CS0 AT[gg Ȃ	*/
										/*	CS1 AT[gg Ȃ	*/
										/*	CS2 AT[gg Ȃ	*/
										/*	CS3 AT[gg Ȃ	*/
	BSC.WCR1.WORD	= 0x0001;			/*	CS0 Wait 1					*/
										/*	CS1 Wait 0					*/
										/*	CS2 Wait 0					*/
										/*	CS3 Wait 0					*/

	/* hn|[gݒ */
	PFC.PACR.WORD	= 0xffff;			/*	PA AhXoX				 */
	PFC.PBCR.WORD	= 0xbfc0;			/*	PB AhXoX				 */
	PFC.PCCR.WORD.H	= 0xC000;			/*	PC15~8 ėpo			 */
	PFC.PCCR.WORD.L	= 0x1fff;			/*	PC oX[q				 */
	PFC.PDCR.WORD	= 0xffff;			/*	PD f[^oX				 */
	PFC.PECR.WORD	= 0x0000;			/*	PE15~0 ėpo			 */
	PFC.PFCR.WORD.H	= 0x0055;			/*	PF oX[q				 */
	PFC.PFCR.WORD.L	= 0x00aa;			/*	PF oX[q				 */
	PFC.PGCR.WORD.H	= 0x0aaa;			/*	PG 							 */
	PFC.PGCR.WORD.L	= 0xbf80;			/*	PG 							 */

	PFC.PAIOR.WORD = 0xffff;			/*[OUT]PA15~PA0					 */
	PFC.PBIOR.WORD = 0xffff;			/*[OUT]PB11~PB0					 */
	PFC.PCIOR.WORD = 0xffff;			/*[OUT]PC14~PC0					 */
	PFC.PDIOR.WORD = 0xffff;			/*[OUT]PD15~PD0					 */
	PFC.PEIOR.WORD = 0xffff;			/*[OUT]PE14~PE0					 */
	PFC.PFIOR.WORD = 0xffff;			/*[OUT]PF7~PF0					 */
	PFC.PGIOR.WORD = 0x0000;			/*[IN]PG15~0					 */

	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	data;
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	atu0_init();						/*	ATU0					*/

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	def_int_hdr(144,(void*)int_cmi0);	/*荞݃nh̐ݒ			*/
	INTC.IPRG.WORD		|= 0x0070;		/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.WORD		&= ~0x0001;		/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD		= 0x0040;		/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR			= 0x6000-1;		/*	(19.6608MHz/8)/24576 = 10msec	*/
	CMT.CMSTR.WORD		|= 0x0001;		/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*bleNA				*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		PC.DR.WORD |= 0x7f80;
		flag = 0;
	} else {
		PC.DR.WORD &= ~0x7f80;
		flag = 1;
	}
	UserLogTimer++;
}

/************************************/
/*	ATU ϰƼ					*/
/************************************/
void atu0_init(void)
{
	unsigned char dummy;

	def_int_hdr(100,(void*)int_atu0);	/*荞݃nh̐ݒ			*/

	INTC.IPRD.WORD |= 0x0007;			/*ATU13(CH1)D惌xVɐݒ	*/

	/*ATU1Tt[jO^C}ɐݒ*/


	ATU.PSCR1.BYTE = 0;					/*䗦 1:1					*/
	ATU.TSTR.WORD = 0x0000;				/*JEg~				*/


	ATU1.TCR.BYTE = 0x05; 				/*オGbWJEg		*/
										/*/32ŃJEg				*/

	ATU1.TIERB.BYTE = 0x40;				/*I[o[t[C^[vg*/
	dummy = ATU1.TSRB.BYTE;				/*_~[[h					*/
	ATU1.TSRB.BYTE = 0 ;				/*Xe[^XNA				*/

	ATU1.TCNT = 0xf400;					/*5ms/((1s/19.6608MHz)~32))	*/
										/*AbvJEĝ0x10000*/

	ATU.TSTR.WORD = 0x0002 ;            /*JE^1X^[g				*/
}

/********************************************/
/*	`stO^C}[荞				*/
/********************************************/
#pragma interrupt
void int_atu0(void)
{
	static char		flag;
	unsigned char	wk;

	wk = ATU1.TSRB.BYTE;				/*_~[[h*/
	ATU1.TSRB.BYTE = 0x00;				/*OVINA*/
	ATU1.TCNT = 0xf400;					/*5ms/((1s/19.6608MHz)~32))	*/
										/*AbvJEĝ0x10000*/

	if( flag == 0 ) {
		PE.DR.WORD = 0xffff;
		flag = 1;

	} else {
		PE.DR.WORD = 0x8000;
		flag = 0;
	}
}

