#include	"7144s.h"
#include	"gmachine.h"
#include	"userlog.h"

/****************************************************************************/
/*CS1 ɐڑĂ SRAM ̃f[^oX̃oX̐ݒsȂ܂B		*/
/*o׎̐ݒł 32bitoXɂȂĂ܂B								*/
/*܂AoXύXꍇÃTCYς܂B					*/
/*āAGCC ̏ꍇɂ sh2f_6a.x ̓eAC ̏ꍇɂ makeall.batA*/
/*makeall6.bat̓eɂύXKvɂȂ܂B								*/
/****************************************************************************/
#define CS1_32BitBus	0				/*CS1 (SRAM) ̃oX
										  16Bit F 0 
										  32Bit F 1*/

#define		UserLogAdd	0xFFFFF000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	mtu0_init(void);
void	int_mtu0(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* X^oC[h̉ */
	MST.CR2.WORD &= ~0x3000;
	
	/* oXݒ */
#if (CS1_32BitBus == 1)
	BSC.BCR1.WORD		= 0x202f;		/*	CS0:16bit	*/
										/*	CS1:32bit	*/
										/*	CS2:16bit	*/
										/*	CS3:16bit	*/
#else
	BSC.BCR1.WORD		= 0x200f;		/*	CS0:16bit	*/
										/*	CS1:16bit	*/
										/*	CS2:16bit	*/
										/*	CS3:16bit	*/
#endif
	
	BSC.BCR2.WORD		= 0x5500;		/*CS0~CS3 1AChTCN*/
	BSC.WCR1.WORD		= 0x0010;		/*CS1 1EFCg*/

	/* hn|[gݒ */
#if (CS1_32BitBus == 1)
	PFC.PACRH.WORD		= 0x5000;		/*WRHH WRHL PA21~16*/
	PFC.PACRL1.WORD		= 0x1540;		/*RD WRH WRL CS1 PA15,10~8*/
	PFC.PACRL2.WORD		= 0x0140;		/*TXD1 RXD1 PA7~5 PA2~0*/
	
	PFC.PBCR1.WORD		= 0x0002;		/*PB9 A20*/
	PFC.PBCR2.WORD		= 0xa005;		/*A19~16 PB5~2*/
	
	PFC.PCCR.WORD		= 0xfffc;		/*A15~2 PC1,0*/
	
	PFC.PDCRH1.WORD		= 0x5555;		/*D31~24*/
	PFC.PDCRH2.WORD		= 0x5555;		/*D23~16*/
	PFC.PDCRL1.WORD		= 0xffff;		/*D15~0*/
	PFC.PDCRL2.WORD		= 0x0000;
#else
	PFC.PACRH.WORD		= 0x0000;		/*PA23~16*/
	PFC.PACRL1.WORD		= 0x1540;		/*RD WRH WRL CS1 PA15,10~8*/
	PFC.PACRL2.WORD		= 0x0140;		/*TXD1 RXD1 PA7~5 PA2~0*/
	
	PFC.PBCR1.WORD		= 0x0000;		/*PB9,8*/
	PFC.PBCR2.WORD		= 0xa005;		/*A19~16 PB5~2*/
	
	PFC.PCCR.WORD		= 0xfffe;		/*A15~1 PC0*/
	
	PFC.PDCRH1.WORD		= 0x0000;		/*PD31~24*/
	PFC.PDCRH2.WORD		= 0x0000;		/*PD23~16*/
	PFC.PDCRL1.WORD		= 0xffff;		/*D15~0*/
	PFC.PDCRL2.WORD		= 0x0000;
#endif
	
	PFC.PECRL1.WORD		= 0x0000;		/*PE15~8*/
	PFC.PECRL2.WORD		= 0x0000;		/*PE7~0*/
	
	PFC.PAIORL.WORD		= 0x87e7;		/*[OUT]PA15,10~5,2~0 
										  [IN] PA13(8Bit Bus)				*/
	PFC.PBIOR.WORD		= 0x023c;		/*[OUT]PB9,5~2    [IN] PB8(8Bit Bus)*/
	PFC.PEIORL.WORD		= 0x8000;		/*[OUT]PE15       [IN] PE14~0		*/

	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	data;
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	mtu0_init();

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	def_int_hdr(144,(void*)int_cmi0);	/*荞݃nh̐ݒ			*/
	INTC.IPRG.WORD		|= 0x0070;		/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.WORD		&= ~0x0001;		/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD		= 0x0040;		/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR			= 30720-1;		/*	(24.576MHz/8)/30720 = 10msec	*/
	CMT.CMSTR.WORD		|= 0x0001;		/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*bleNA				*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		PA.DR.WORD.L	|= 0x87e7;
		flag = 0;
	} else {
		PA.DR.WORD.L	&= ~0x87e7;
		flag = 1;
	}
	UserLogTimer++;
}

/************************************/
/*	MTU0						*/
/************************************/
void mtu0_init(void)
{

	def_int_hdr(88,(void*)int_mtu0);	/*荞݃nh̐ݒ			*/
	INTC.IPRD.WORD		|= 0x7000;		/*	MTU0 InterruptLevel = 7			*/


	MTU0.TCR.BYTE		= 0x23;			/*sfq`̃RyA}b`			*/
										/*オGbWŃJEg		*/
										/*Ӂ^USŃJEg				*/
	MTU0.TIOR.BYTE.H	= 0x00;			/*TGR0B,TGR0A						*/
	MTU0.TIOR.BYTE.L	= 0x00;			/*TGR0D,TGR0C						*/
	MTU0.TIER.BYTE		= 0x41;			/*sfe`荞ݗv		*/
	MTU0.TGRA			= 1920-1;		/*TJE^					*/
	MTU0.TCNT			= 0x0000;		/*JE^NA					*/
	MTU0.TSR.BYTE		= 0x00;			/*Xe[^XNA					*/

	MTU.TSTR.BYTE		= 0x01;			/*X^[gWX^					*/
}

/************************************/
/*	MTU0荞					*/
/************************************/
#pragma interrupt
void int_mtu0(void)
{
	static char		flag;
	static short	count = 0;

	MTU0.TSR.BYTE		&= ~0x01;		/*TGFANA						*/

	/*	|[gON/OFF	*/
	if( flag == 0 ) {
		PB.DR.WORD |= 0x023c;
		flag = 1;
	} else {
		PB.DR.WORD &= ~0x023c;
		flag = 0;
	}
	
	/*	LEDON/OFF	*/
	count++;
	if ( 100 <= count ) {
		count = 0;
		PE.DRL.WORD ^= 0x8000;			/*	Port E	*/
	}
}
